require 'find'
class RD2HTML
  RD2 = 'rd2 --output-index -o'
  def initialize(docdir)
    @rmi_files = []
    @docdir = docdir
    Dir.chdir(@docdir)
  end

  def out_file(in_file)
    in_file.sub(/\.rd$/, '')
  end

  def cmd_rd2html(in_file)
    RD2 + out_file(in_file) + " " + in_file
  end

  def create_html_files
    Find.find(".") {|f|
      if /\.rd$/ =~ f
        create(f)
      end
    }
  end

  def create(in_file)
    system cmd_rd2html(in_file)
    rmi_file = in_file.sub(/\.rd$/, ".rmi")
    if File.exist?(rmi_file)
      @rmi_files << rmi_file
    end
  end

  def cmd_rmi2html
    "rmi2html.rb " + @rmi_files.join(" ") + " > index.html"
  end

  def create_index_file
    system cmd_rmi2html
  end

  def rm_html_files
    Find.find(".") do |f|
      if /\.html/ =~ f 
	File.unlink(f)
      end
    end
  end

  def rm_rmi_files
    Find.find(".") do |f|
      if /\.rmi/ =~ f 
	File.unlink(f)
      end
    end
  end
end

if __FILE__ == $0
  $pwd = Dir.pwd
  ['doc_en', 'doc_ja'].each do |docdir|
    Dir.chdir($pwd)
    en_doc = RD2HTML.new(docdir)
    if ARGV[0] == 'clean'
      en_doc.rm_html_files
    else
      en_doc.create_html_files
      en_doc.create_index_file
    end
    en_doc.rm_rmi_files
  end
end

