require 'runit/testcase'
require 'runit/cui/testrunner'

require 'runit/testresult'

class DummyTestCaseTestTestResult < RUNIT::TestCase
  def test_1
    assert(true)
    assert(true)
  end
end

class DummyTestCaseTestTestResult2 < RUNIT::TestCase
  def test_1
    assert(true)
    assert(false)
  end
end

class DummyTestCaseTestTestResult3 < RUNIT::TestCase
  def setup
    raise ScriptError
  end
  def test_1
    assert(true)
  end
end

class TestRUNIT__TestResult < RUNIT::TestCase

  def setup
    @result = RUNIT::TestResult.new
    @suite = DummyTestCaseTestTestResult.suite
    @suite2 = DummyTestCaseTestTestResult2.suite
	@suite3 = DummyTestCaseTestTestResult3.suite
  end

  def test_error_size
    @suite.run(@result)
    assert_equal(0, @result.error_size)
  end

  def test_errors
    @suite.run(@result)
    assert_equal(0, @result.errors.size)
  end

  def test_failure_size
    @suite.run(@result)
    assert_equal(0, @result.failure_size)
  end

  def test_failures
    @suite.run(@result)
    assert_equal(0, @result.failures.size)
  end

  def test_run
#    assert(false, "untested")
  end

  def test_run_no_exception
    assert_no_exception {
      @suite3.run(@result)
	}
  end

  def test_run_asserts
    @suite.run(@result)
    assert_equal(2, @result.run_asserts)
  end

  def test_run_asserts2
    @suite2.run(@result)
    assert_equal(2, @result.run_asserts)
  end

  def test_run_tests
    assert_equal(0, @result.run_tests)
    @suite.run(@result)
    assert_equal(1, @result.run_tests)
  end

  def test_succeed?
    @suite.run(@result)
    assert(@result.succeed?)
  end

  def test_update
#    assert(false, "untested")
  end

end

if $0 == __FILE__
  testrunner = RUNIT::CUI::TestRunner.new
  if ARGV.size == 0
    suite = TestRUNIT__TestResult.suite
  else
    suite = RUNIT::TestSuite.new
    ARGV.each do |testmethod|
      suite.add_test(TestRUNIT__TestResult.new(testmethod))
    end
  end
  testrunner.run(suite)
end
