require 'runit/testcase'
require 'runit/cui/testrunner'

class NothingTest < RUNIT::TestCase
end

class DummyTest < RUNIT::TestCase
  def test_foo
  end
  def test_bar
  end
end

class TestTestSuite < RUNIT::TestCase
  def setup
    @testsuite = RUNIT::TestSuite.new
  end

  def test_count_test_cases
    assert_equal(0, @testsuite.count_test_cases)

    @testsuite.add_test(NothingTest.suite)
    assert_equal(0, @testsuite.count_test_cases)

    @testsuite.add_test(DummyTest.suite)
    assert_equal(2, @testsuite.count_test_cases)

    @testsuite.add_test(DummyTest.suite)
    assert_equal(4, @testsuite.count_test_cases)

    dummytest_foo = DummyTest.new('test_foo')
    @testsuite.add_test(dummytest_foo)
    assert_equal(5, @testsuite.count_test_cases)
  end

  def test_add_test
    tests = @testsuite.add_test(NothingTest.suite)
    assert_equal(1, tests.size)

    tests = @testsuite.add_test(DummyTest.suite)
    assert_equal(2, tests.size)
  end
end

if $0 == __FILE__
  RUNIT::CUI::TestRunner.run(TestTestSuite.suite)
end

